<?php
/**
 * Copyright (C) 2020-21 Leads5050 / CreatorSEO (email : info@creatorseo.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License, version 3, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You can find a copy of the GNU General Public License at the link
 * http://www.gnu.org/licenses/gpl.html or write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

/**
 * Create a basic chart - for later version of this plugin
 *
 * @param $atts attributes
 * @param null $content - the title
 *
 * @return string
 */
function leads5050_template_basic( $atts, $content=null ) {
	$atts = shortcode_atts(
		array(
			'chart_id' => 'myChart',
			'title' => 'DEBUG INFORMATION',
			'type' => 'chart'
		),
		$atts
	);
	$out = '';
	$allowedCharts = array('myChart', 'lineChart', 'barChart', 'timelineChart');
	$atts['chart_id'] = in_array($atts['chart_id'],$allowedCharts)? $atts['chart_id']: 'myChartX';
	$atts['type'] = strtolower(in_array($atts['type'],array('chart', 'table'))? $atts['api']: 'chart');
	$title = (is_null($content) || strlen($content)==0)? $atts['title']: $content;
	$out .= '<h2>'.$title.'</h2>';
	//$out .= '<pre>'.var_export($atts,true).'</pre>';
	$out .= '<div class="ract_container">';
		$out .= '<canvas id="'.esc_attr($atts['chart_id']).'"></canvas>';
		$out .= '<canvas id="timeChart"></canvas>';
		$out .= '<canvas id="scatterChart"></canvas>';
		$out .= '<canvas id="xyChart"></canvas>';
		$out .= '<canvas id="myChart"></canvas>';
	$out .= '</div>';

	return $out;
}
add_shortcode( 'leads5050_template_basic', 'leads5050_template_basic' );

/**
 * Add the leads map to a page using a shortcode
 *
 * @param $atts attributes
 * @param null $content - the title
 *
 * @return string
 */
function leads5050_map_on_page( $atts, $content=null ) {
    $atts = shortcode_atts(
        array(
            'chart_id' => 'myChart',
            'title' => 'DEBUG INFORMATION',
            'type' => 'map',
            'api' => 'XXXXX'
        ),
        $atts
    );
    wp_enqueue_style( 'leads5050-map' );
    wp_enqueue_script( 'leads5050-map' );
    wp_enqueue_script( 'leads5050-map1' );
    $out = '';
    $api = isset($atts['api']) && strlen($atts['api'])==5? sanitize_text_field($atts['api']): 'XXXXX';
    //ToDo: need to get the API value and add it at the XXXXX or add a rest function that retrieves the data without the API
    $out .= "<div id='leads5050-visitor-map'><span id='leads5050-api-key-value'>".$api."</span>";
    $out .= "<div id='leads5050_visit_map' class='leads5050_map'></div>";
    $out .= "<div class='leads5050_status'><em>Status: </em><span id='leads5050_map_status'>Loading map...</span></div>";
    $out .= "</div>";

    return $out;
}
add_shortcode( 'leads5050_map_on_page', 'leads5050_map_on_page' );